'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.LOGOUT = exports.LOGIN = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dispatcher = require('../dispatcher');

var _dispatcher2 = _interopRequireDefault(_dispatcher);

var _storage = require('../storage');

var _storage2 = _interopRequireDefault(_storage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LOGIN = exports.LOGIN = "LOGIN";
var LOGOUT = exports.LOGOUT = "LOGOUT";

/**
 * Auth Flux Store
 */

var AuthStore = function (_ReduceStore) {
	_inherits(AuthStore, _ReduceStore);

	function AuthStore() {
		_classCallCheck(this, AuthStore);

		return _possibleConstructorReturn(this, Object.getPrototypeOf(AuthStore).apply(this, arguments));
	}

	_createClass(AuthStore, [{
		key: 'getInitialState',


		/**
   * Setup the default state for the store
   * 
   * @return {Object} default (initial) state
   */
		value: function getInitialState() {
			return {
				token: _storage2.default.get('reaction.token')
			};
		}

		/**
   * Reduction function to handle relevent events
   * from the dispatcher
   * 
   * @param  {Object} state  previous state
   * @param  {Object} action current action
   * @return {Object}        new state
   */

	}, {
		key: 'reduce',
		value: function reduce(state, action) {
			switch (action.type) {
				case LOGIN:
					_storage2.default.get('reaction.token', action.token);
					return state.set('token', action.token);
				case LOGOUT:
					_storage2.default.remove('reaction.token');
					return state.set('token', null);
				default:
					return state;
			}
		}
	}]);

	return AuthStore;
}(ReduceStore);

exports.default = new AuthStore(_dispatcher2.default);