"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * ACL Class
 */

var Acl = function () {
	function Acl() {
		_classCallCheck(this, Acl);

		this._whitelist = {};
		this._blacklist = {};
	}

	_createClass(Acl, [{
		key: "can",


		/**
   * Check if a given user can complete this task
   * 
   * @param  {User}    user   the current User
   * @param  {String}  key    the key for the given task
   * @param  {Object}  obj    [optional] the object in question
   * @return {Boolean}        whether or not the User has permission
   */
		value: function can(user, key, obj) {
			var white = this._whitelist[key];
			var black = this._blacklist[key];

			return !black(user, obj) && !!white(user, obj);
		}

		/**
   * Inverse of `this.can`
   * 
   * @param  {User}    user   the current User
   * @param  {String}  key    the key for the given task
   * @param  {Object}  obj    [optional] the object in question
   * @return {Boolean}        whether or not the User has permission
   */

	}, {
		key: "cannot",
		value: function cannot() {
			return !this.can.apply(this, arguments);
		}

		/**
   * Set an `allow` rule
   * 
   * @param  {String}     key   the key for the permission
   * @param  {Function}   fn    callback to be run during permission check
   * @return {null}       
   */

	}, {
		key: "allow",
		value: function allow(key, fn) {
			this._whitelist[key] = fn;
		}

		/**
   * Set a `deny` rule
   * 
   * @param  {String}     key   the key for the permission
   * @param  {Function}   fn    callback to be run during permission check
   * @return {null}       
   */

	}, {
		key: "deny",
		value: function deny(key, fn) {
			this._blacklist[key] = fn;
		}
	}]);

	return Acl;
}();

exports.default = new Acl();