'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _graphqlRelay = require('graphql-relay');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var PREFIX = 'arrayconnection:';
var DEFAULT_LIMIT = _config2.default.get('app.paginationLimit');

var Connection = function () {
	_createClass(Connection, null, [{
		key: 'getType',
		value: function getType(name) {
			return (0, _graphqlRelay.connectionDefinitions)({
				name: name,
				nodeType: name
			}).connectionType;
		}
	}]);

	function Connection(Model) {
		_classCallCheck(this, Connection);

		this.Model = Model;
	}

	_createClass(Connection, [{
		key: 'query',
		value: function query(_query, args) {
			var _this = this;

			return new Promise(function (resolve, reject) {
				var _parseArgs = _this.parseArgs(args);

				var offset = _parseArgs.offset;
				var limit = _parseArgs.limit;


				_query.offset(offset).limit(limit + 1).then(function (result) {
					resolve(_this.parseResult(result, args));
				});
			});
		}
	}, {
		key: 'parseArgs',
		value: function parseArgs(args) {
			var before = args.before;
			var after = args.after;
			var first = args.first;
			var last = args.last;


			var offset = 0,
			    limit = DEFAULT_LIMIT;

			if (before && after) {
				console.warn('Cannot combine before and after, before will be ignored');
			}

			if (after) {
				offset = this.getOffset(after) || 0;
				limit = parseInt(first || DEFAULT_LIMIT, 10);
			} else if (before) {
				limit = parseInt(last || DEFAULT_LIMIT, 10);
				offset = Math.max(0, (this.getOffset(before) || 0) - limit);
			}

			return { offset: offset, limit: limit };
		}
	}, {
		key: 'parseResult',
		value: function parseResult(result, args) {
			var _this2 = this;

			var ret = this.emptyConnection();

			var before = args.before;
			var after = args.after;
			var first = args.first;
			var last = args.last;

			var _parseArgs2 = this.parseArgs(args);

			var offset = _parseArgs2.offset;
			var limit = _parseArgs2.limit;


			if (result.length) {
				(function () {
					if (result.length > limit) {
						ret.pageInfo.hasNextPage = true;
						result.pop();
					}

					var startIdx = after ? offset + 1 : offset;

					var edges = result.map(function (props, idx) {
						return {
							cursor: _this2.offsetToCursor(startIdx + idx),
							node: new _this2.Model(props)
						};
					});

					if (first) edges = edges.slice(0, first);
					if (last) edges = edges.slice(-last);

					ret.edges = edges;
					ret.pageInfo.startCursor = edges[0].cursor;
					ret.pageInfo.startCursor = edges[0].cursor;
					ret.pageInfo.hasPreviousPage = _this2.cursorToOffset(edges[0].cursor) > 0;
				})();
			}

			return ret;
		}
	}, {
		key: 'emptyConnection',
		value: function emptyConnection() {
			return {
				edges: [],
				pageInfo: {
					startCursor: null,
					endCursor: null,
					hasPreviousPage: false,
					hasNextPage: false
				}
			};
		}
	}, {
		key: 'offsetToCursor',
		value: function offsetToCursor(offset) {
			return new Buffer(PREFIX + offset).toString('base64');
		}
	}, {
		key: 'cursorToOffset',
		value: function cursorToOffset(cursor) {
			var key = void 0,
			    num = void 0;

			key = new Buffer(cursor, 'base64').toString('ascii');

			num = parseInt(key.substring(PREFIX.length), 10);

			return isNaN(num) ? 0 : num;
		}
	}, {
		key: 'getOffset',
		value: function getOffset(cursor) {
			if (typeof cursor === 'undefined' || cursor === null) return;

			return this.cursorToOffset(cursor);
		}
	}]);

	return Connection;
}();

exports.default = Connection;