'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _graphql = require('graphql');

var _utilities = require('graphql/utilities');

var _graphqlRelay = require('graphql-relay');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Schema = function () {
	function Schema() {
		_classCallCheck(this, Schema);

		this._registry = {};
		this._queries = {};
		this._mutations = {};
		this._types = {};
		this._resolves = [];

		this.register('id', _graphql.GraphQLID);
		this.register('string', _graphql.GraphQLString);
		this.register('int', _graphql.GraphQLInt);
		this.register('integer', _graphql.GraphQLInt);
		this.register('date', _graphql.GraphQLString);
		this.register('bool', _graphql.GraphQLBoolean);
		this.register('boolean', _graphql.GraphQLBoolean);
	}

	_createClass(Schema, [{
		key: 'register',
		value: function register(name, inst) {
			this._registry[name] = inst;

			return inst;
		}
	}, {
		key: 'make',
		value: function make(name) {
			if (_lodash2.default.isObject(name)) {
				return name;
			}
			if (_lodash2.default.isString(name)) {
				return this._registry[name];
			}
			return;
		}
	}, {
		key: 'model',
		value: function model(name, Model) {
			// this.register(name, Model)
			// if(_.isString(Model)){
			// 	return bookshelf.model(Model)
			// }

			// let inst = bookshelf.model(name)

			// if( ! inst){
			// 	inst = bookshelf.model(name, Model)
			// }

			// return inst
		}
	}, {
		key: 'type',
		value: function type(name, _type) {
			this._types[name] = _type;
		}
	}, {
		key: 'query',
		value: function query(name, _query) {
			this._queries[name] = _query;
		}
	}, {
		key: 'mutation',
		value: function mutation(name, _mutation) {
			this._mutations[name] = _mutation;
		}
	}, {
		key: 'subscription',
		value: function subscription(name) {}
	}, {
		key: 'resolveTypes',
		value: function resolveTypes(obj) {
			for (var key in obj) {
				if (key == 'type') {
					if (obj.type instanceof _graphql.GraphQLObjectType) {
						if (_lodash2.default.isFunction(obj.type._typeConfig.fields)) {
							var fields = obj.type._typeConfig.fields();

							fields.edges.type.ofType._typeConfig.fields = fields.edges.type.ofType._typeConfig.fields();
							fields.edges.type.ofType._typeConfig.fields.node.type = this.resolveType(fields.edges.type.ofType._typeConfig.fields.node.type);

							obj.type._typeConfig.fields = this.resolveTypes(fields);
						}
					} else if (_lodash2.default.isString(obj.type) && obj.type.substr(0, 3) === 'id:') {
						obj = (0, _graphqlRelay.globalIdField)(obj.type.replace('id:'));
					} else {
						obj.type = this.resolveType(obj.type);
					}
				} else if (_lodash2.default.isObject(obj[key])) {
					obj[key] = this.resolveTypes(obj[key]);
				}
			}

			return obj;
		}
	}, {
		key: 'resolveType',
		value: function resolveType(name) {
			var made = this.make(name);
			if (made) {
				return made;
			}

			var data = this._types[name],
			    type = new _graphql.GraphQLObjectType({
				name: name,
				description: '',
				fields: data
			});

			made = this.register(name, type);

			this._resolves.push(name);

			return made;
		}
	}, {
		key: 'getQueryFields',
		value: function getQueryFields() {
			var fields = {};

			for (var name in this._queries) {
				var query = this._queries[name];
				fields[name] = this.resolveTypes(query);
			}

			while (this._resolves.length) {
				var cur = this._resolves.shift(),
				    m = this.make(cur);

				m._typeConfig.fields = this.resolveTypes(m._typeConfig.fields);

				this.register(name, m);
			}

			return fields;
		}
	}, {
		key: 'toGraphQL',
		value: function toGraphQL() {
			return new _graphql.GraphQLSchema({
				query: new _graphql.GraphQLObjectType({
					name: 'Query',
					fields: this.getQueryFields()
				})
			});
		}
	}, {
		key: 'toGraphQLJSON',
		value: function toGraphQLJSON() {
			var _this = this;

			return new Promise(function (resolve, reject) {
				(0, _graphql.graphql)(_this.toGraphQL(), _utilities.introspectionQuery).then(function (result) {
					resolve(JSON.stringify(result, null, 2));
				}).catch(function (err) {
					reject(err);
				});
			});
		}
	}]);

	return Schema;
}();

exports.default = new Schema();