"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Storage Class
 *
 * TODO abstract off of localStorage
 * the whole point of this app is to have a standard
 * interface to work with regardless of your environment
 */

var Storage = function () {
	function Storage() {
		_classCallCheck(this, Storage);
	}

	_createClass(Storage, [{
		key: "get",


		/**
   * Get Item from Storage
   * 
   * @param  {String} key name of the item in storage
   * @return {Mixed}
   */
		value: function get(key) {
			return localStorage.getItem(key);
		}

		/**
   * Set an Item in Storage
   * 
   * @param {String} key name of the item in Storage
   * @param {Mixed} val
   */

	}, {
		key: "set",
		value: function set(key, val) {
			if (!_.isString(val)) {
				val = JSON.stringify(val);
			}

			localStorage.setItem(key, val);
		}

		/**
   * Remove an Item from Storage
   * 
   * @param {String} key name of the item in Storage
   * @param {Boolean} val true
   */

	}, {
		key: "remove",
		value: function remove(key) {
			localStorage.removeItem(key);

			return true;
		}
	}]);

	return Storage;
}();

exports.default = new Storage();