var expect = require("chai").expect;

var config = require('../../lib/config').default;

beforeEach(function(){
	config._config = {}
});

describe("Config tests", function(){
	describe("Mutators", function(){
		it('sets a value into the _config object', function(){
			config.set('foo', 'bar');
			expect(config._config.foo).to.equal('bar');
		});

		it('receives a value from the _config object', function(){
			config._config.foo = 'bar';
			expect(config.get('foo')).to.equal('bar');
		});

		it('sets nested values', function(){
			config.set('foo.bar', 'test');
			expect(config._config.foo).to.be.an('object');
			expect(config._config.foo.bar).to.equal('test');
		});

		it('retrieves nested values', function(){
			config._config = {
				foo: {
					bar: 'test'
				}
			};

			expect(config.get('foo.bar')).to.equal('test');
		});
	});
});